/*
 * MATLAB Compiler: 3.0
 * Date: Wed Aug 25 13:39:08 2004
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-W" "main" "-L" "C"
 * "-t" "-T" "link:lib" "-h" "test_track" "libmmfile.mlib" "-v" 
 */
#include "compute_local_features_window.h"
#include "libmatlbm.h"
static mxArray * _mxarray0_;
static mxArray * _mxarray1_;

static double _array3_[3] = { 5.0, 3.0, 3.0 };
static mxArray * _mxarray2_;

static double _array5_[3] = { 8.0, 8.0, 4.0 };
static mxArray * _mxarray4_;
static mxArray * _mxarray6_;
static mxArray * _mxarray7_;

void InitializeModule_compute_local_features_window(void) {
    _mxarray0_ = mclInitializeDouble(2.0);
    _mxarray1_ = mclInitializeDouble(1.0);
    _mxarray2_ = mclInitializeDoubleVector(1, 3, _array3_);
    _mxarray4_ = mclInitializeDoubleVector(1, 3, _array5_);
    _mxarray6_ = mclInitializeDouble(0.0);
    _mxarray7_ = mclInitializeDoubleVector(0, 0, (double *)NULL);
}

void TerminateModule_compute_local_features_window(void) {
    mxDestroyArray(_mxarray7_);
    mxDestroyArray(_mxarray6_);
    mxDestroyArray(_mxarray4_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray1_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mcompute_local_features_window(int nargout_,
                                                mxArray * data_fft,
                                                mxArray * fft_pow);

_mexLocalFunctionTable _local_function_table_compute_local_features_window
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfCompute_local_features_window" contains the normal
 * interface for the "compute_local_features_window" M-function from file
 * "/afs/cs.cmu.edu/user/dhoiem/code_for_c/compute_local_features_window.m"
 * (lines 1-30). This function processes any input arguments and passes them to
 * the implementation version of the function, appearing above.
 */
mxArray * mlfCompute_local_features_window(mxArray * data_fft,
                                           mxArray * fft_pow) {
    int nargout = 1;
    mxArray * features = NULL;
    mlfEnterNewContext(0, 2, data_fft, fft_pow);
    features = Mcompute_local_features_window(nargout, data_fft, fft_pow);
    mlfRestorePreviousContext(0, 2, data_fft, fft_pow);
    return mlfReturnValue(features);
}

/*
 * The function "mlxCompute_local_features_window" contains the feval interface
 * for the "compute_local_features_window" M-function from file
 * "/afs/cs.cmu.edu/user/dhoiem/code_for_c/compute_local_features_window.m"
 * (lines 1-30). The feval function calls the implementation version of
 * compute_local_features_window through this function. This function processes
 * any input arguments and passes them to the implementation version of the
 * function, appearing above.
 */
void mlxCompute_local_features_window(int nlhs,
                                      mxArray * plhs[],
                                      int nrhs,
                                      mxArray * prhs[]) {
    mxArray * mprhs[2];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: compute_local_features_window Line: 4 "
            "Column: 1 The function \"compute_local_features_window\" was"
            " called with more than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: compute_local_features_window Line: 4 "
            "Column: 1 The function \"compute_local_features_window\" was"
            " called with more than the declared number of inputs (2)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 2 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 2; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 2, mprhs[0], mprhs[1]);
    mplhs[0] = Mcompute_local_features_window(nlhs, mprhs[0], mprhs[1]);
    mlfRestorePreviousContext(0, 2, mprhs[0], mprhs[1]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mcompute_local_features_window" is the implementation version
 * of the "compute_local_features_window" M-function from file
 * "/afs/cs.cmu.edu/user/dhoiem/code_for_c/compute_local_features_window.m"
 * (lines 1-30). It contains the actual compiled code for that M-function. It
 * is a static function and must only be called from one of the interface
 * functions, appearing below.
 */
/*
 * % compute features for a window that describe the distribution
 * % currently, 87 features
 * % data_fft(num_bands, num_times)
 * function features = compute_local_features_window(data_fft, fft_pow)
 */
static mxArray * Mcompute_local_features_window(int nargout_,
                                                mxArray * data_fft,
                                                mxArray * fft_pow) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(
          &_local_function_table_compute_local_features_window);
    mxArray * features = NULL;
    mxArray * b2 = NULL;
    mxArray * b1 = NULL;
    mxArray * b = NULL;
    mxArray * t2 = NULL;
    mxArray * t1 = NULL;
    mxArray * t = NULL;
    mxArray * r = NULL;
    mxArray * count = NULL;
    mxArray * band_width = NULL;
    mxArray * time_width = NULL;
    mxArray * num_bands = NULL;
    mxArray * num_times = NULL;
    mclCopyArray(&data_fft);
    mclCopyArray(&fft_pow);
    /*
     * 
     * num_times = size(data_fft, 2);
     */
    mlfAssign(
      &num_times,
      mlfSize(mclValueVarargout(), mclVa(data_fft, "data_fft"), _mxarray0_));
    /*
     * num_bands = size(data_fft, 1);
     */
    mlfAssign(
      &num_bands,
      mlfSize(mclValueVarargout(), mclVa(data_fft, "data_fft"), _mxarray1_));
    /*
     * 
     * time_width = [5 3 3];
     */
    mlfAssign(&time_width, _mxarray2_);
    /*
     * band_width = [8 8 4];
     */
    mlfAssign(&band_width, _mxarray4_);
    /*
     * 
     * features = zeros(sum(time_width.*(band_width+1)), 1);
     */
    mlfAssign(
      &features,
      mlfZeros(
        mlfSum(
          mclTimes(
            mclVv(time_width, "time_width"),
            mclPlus(mclVv(band_width, "band_width"), _mxarray1_)),
          NULL),
        _mxarray1_,
        NULL));
    /*
     * 
     * count = 0;
     */
    mlfAssign(&count, _mxarray6_);
    /*
     * for r = 1:length(time_width)                        
     */
    {
        int v_ = mclForIntStart(1);
        int e_ = mclLengthInt(mclVv(time_width, "time_width"));
        if (v_ > e_) {
            mlfAssign(&r, _mxarray7_);
        } else {
            /*
             * for t = 1:time_width(r)
             * t1 = floor((t-1)*num_times/time_width(r))+1;
             * t2 = floor(t*num_times/time_width(r));
             * for b = 1:band_width(r)
             * b1 = floor((b-1)*num_bands/band_width(r))+1;
             * b2 = floor(b*num_bands/band_width(r));
             * count = count + 1;
             * features(count) = sum(sum(data_fft(b1:b2, t1:t2)));
             * end
             * count= count + 1;
             * features(count) = sum(fft_pow(t1:t2));
             * end
             * end
             */
            for (; ; ) {
                int v_0 = mclForIntStart(1);
                int e_0
                  = mclForIntEnd(
                      mclIntArrayRef1(mclVv(time_width, "time_width"), v_));
                if (v_0 > e_0) {
                    mlfAssign(&t, _mxarray7_);
                } else {
                    for (; ; ) {
                        mlfAssign(
                          &t1,
                          mclPlus(
                            mlfFloor(
                              mclMrdivide(
                                mclMtimes(
                                  mlfScalar(v_0 - 1),
                                  mclVv(num_times, "num_times")),
                                mclIntArrayRef1(
                                  mclVv(time_width, "time_width"), v_))),
                            _mxarray1_));
                        mlfAssign(
                          &t2,
                          mlfFloor(
                            mclMrdivide(
                              mclMtimes(
                                mlfScalar(v_0), mclVv(num_times, "num_times")),
                              mclIntArrayRef1(
                                mclVv(time_width, "time_width"), v_))));
                        {
                            int v_1 = mclForIntStart(1);
                            int e_1
                              = mclForIntEnd(
                                  mclIntArrayRef1(
                                    mclVv(band_width, "band_width"), v_));
                            if (v_1 > e_1) {
                                mlfAssign(&b, _mxarray7_);
                            } else {
                                for (; ; ) {
                                    mlfAssign(
                                      &b1,
                                      mclPlus(
                                        mlfFloor(
                                          mclMrdivide(
                                            mclMtimes(
                                              mlfScalar(v_1 - 1),
                                              mclVv(num_bands, "num_bands")),
                                            mclIntArrayRef1(
                                              mclVv(band_width, "band_width"),
                                              v_))),
                                        _mxarray1_));
                                    mlfAssign(
                                      &b2,
                                      mlfFloor(
                                        mclMrdivide(
                                          mclMtimes(
                                            mlfScalar(v_1),
                                            mclVv(num_bands, "num_bands")),
                                          mclIntArrayRef1(
                                            mclVv(band_width, "band_width"),
                                            v_))));
                                    mlfAssign(
                                      &count,
                                      mclPlus(
                                        mclVv(count, "count"), _mxarray1_));
                                    mclArrayAssign1(
                                      &features,
                                      mlfSum(
                                        mlfSum(
                                          mclArrayRef2(
                                            mclVa(data_fft, "data_fft"),
                                            mlfColon(
                                              mclVv(b1, "b1"),
                                              mclVv(b2, "b2"),
                                              NULL),
                                            mlfColon(
                                              mclVv(t1, "t1"),
                                              mclVv(t2, "t2"),
                                              NULL)),
                                          NULL),
                                        NULL),
                                      mclVv(count, "count"));
                                    if (v_1 == e_1) {
                                        break;
                                    }
                                    ++v_1;
                                }
                                mlfAssign(&b, mlfScalar(v_1));
                            }
                        }
                        mlfAssign(
                          &count, mclPlus(mclVv(count, "count"), _mxarray1_));
                        mclArrayAssign1(
                          &features,
                          mlfSum(
                            mclArrayRef1(
                              mclVa(fft_pow, "fft_pow"),
                              mlfColon(mclVv(t1, "t1"), mclVv(t2, "t2"), NULL)),
                            NULL),
                          mclVv(count, "count"));
                        if (v_0 == e_0) {
                            break;
                        }
                        ++v_0;
                    }
                    mlfAssign(&t, mlfScalar(v_0));
                }
                if (v_ == e_) {
                    break;
                }
                ++v_;
            }
            mlfAssign(&r, mlfScalar(v_));
        }
    }
    mclValidateOutput(
      features, 1, nargout_, "features", "compute_local_features_window");
    mxDestroyArray(num_times);
    mxDestroyArray(num_bands);
    mxDestroyArray(time_width);
    mxDestroyArray(band_width);
    mxDestroyArray(count);
    mxDestroyArray(r);
    mxDestroyArray(t);
    mxDestroyArray(t1);
    mxDestroyArray(t2);
    mxDestroyArray(b);
    mxDestroyArray(b1);
    mxDestroyArray(b2);
    mxDestroyArray(fft_pow);
    mxDestroyArray(data_fft);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return features;
    /*
     * 
     * 
     */
}
