/*
 * MATLAB Compiler: 3.0
 * Date: Wed Aug 25 13:39:07 2004
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-W" "main" "-L" "C"
 * "-t" "-T" "link:lib" "-h" "test_track" "libmmfile.mlib" "-v" 
 */
#include "test_track.h"
#include "extract_global_features_track.h"
#include "libmatlbm.h"
#include "libmmfile.h"
#include "remove_close_matches.h"
#include "treeval.h"
static mxArray * _mxarray0_;
static mxArray * _mxarray1_;
static mxArray * _mxarray2_;
static mxArray * _mxarray3_;
static mxArray * _mxarray4_;

void InitializeModule_test_track(void) {
    _mxarray0_ = mclInitializeDouble(1.0);
    _mxarray1_ = mclInitializeDouble(8.0);
    _mxarray2_ = mclInitializeDouble(0.0);
    _mxarray3_ = mclInitializeDoubleVector(0, 0, (double *)NULL);
    _mxarray4_ = mclInitializeDouble(2.0);
}

void TerminateModule_test_track(void) {
    mxDestroyArray(_mxarray4_);
    mxDestroyArray(_mxarray3_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray1_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mtest_track(mxArray * * confidences,
                             int nargout_,
                             mxArray * track,
                             mxArray * global_classifiers);

_mexLocalFunctionTable _local_function_table_test_track
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfTest_track" contains the normal interface for the
 * "test_track" M-function from file
 * "/afs/cs.cmu.edu/user/dhoiem/code_for_c/test_track.m" (lines 1-71). This
 * function processes any input arguments and passes them to the implementation
 * version of the function, appearing above.
 */
mxArray * mlfTest_track(mxArray * * confidences,
                        mxArray * track,
                        mxArray * global_classifiers) {
    int nargout = 1;
    mxArray * passed_times = NULL;
    mxArray * confidences__ = NULL;
    mlfEnterNewContext(1, 2, confidences, track, global_classifiers);
    if (confidences != NULL) {
        ++nargout;
    }
    passed_times
      = Mtest_track(&confidences__, nargout, track, global_classifiers);
    mlfRestorePreviousContext(1, 2, confidences, track, global_classifiers);
    if (confidences != NULL) {
        mclCopyOutputArg(confidences, confidences__);
    } else {
        mxDestroyArray(confidences__);
    }
    return mlfReturnValue(passed_times);
}

/*
 * The function "mlxTest_track" contains the feval interface for the
 * "test_track" M-function from file
 * "/afs/cs.cmu.edu/user/dhoiem/code_for_c/test_track.m" (lines 1-71). The
 * feval function calls the implementation version of test_track through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxTest_track(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[2];
    mxArray * mplhs[2];
    int i;
    if (nlhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: test_track Line: 5 Column:"
            " 1 The function \"test_track\" was called with m"
            "ore than the declared number of outputs (2)."),
          NULL);
    }
    if (nrhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: test_track Line: 5 Column"
            ": 1 The function \"test_track\" was called with"
            " more than the declared number of inputs (2)."),
          NULL);
    }
    for (i = 0; i < 2; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 2 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 2; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 2, mprhs[0], mprhs[1]);
    mplhs[0] = Mtest_track(&mplhs[1], nlhs, mprhs[0], mprhs[1]);
    mlfRestorePreviousContext(0, 2, mprhs[0], mprhs[1]);
    plhs[0] = mplhs[0];
    for (i = 1; i < 2 && i < nlhs; ++i) {
        plhs[i] = mplhs[i];
    }
    for (; i < 2; ++i) {
        mxDestroyArray(mplhs[i]);
    }
}

/*
 * The function "Mtest_track" is the implementation version of the "test_track"
 * M-function from file "/afs/cs.cmu.edu/user/dhoiem/code_for_c/test_track.m"
 * (lines 1-71). It contains the actual compiled code for that M-function. It
 * is a static function and must only be called from one of the interface
 * functions, appearing below.
 */
/*
 * % global_classifier.{ fft_params.{ fs, window_size, band_boundaries, overlapping_windows }, 
 * %                     tree }
 * % search_params.{ window_size, window_step }
 * % note: passed times (in seconds) has close times removed
 * function [passed_times, confidences] = ...
 */
static mxArray * Mtest_track(mxArray * * confidences,
                             int nargout_,
                             mxArray * track,
                             mxArray * global_classifiers) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_test_track);
    mxArray * passed_times = NULL;
    mxArray * X = NULL;
    mxArray * confidences2 = NULL;
    mxArray * width = NULL;
    mxArray * fs = NULL;
    mxArray * passed_data = NULL;
    mxArray * num_passed = NULL;
    mxArray * s = NULL;
    mxArray * node_ids = NULL;
    mxArray * class_labels = NULL;
    mxArray * t = NULL;
    mxArray * num_trees = NULL;
    mxArray * stage = NULL;
    mxArray * passed_indices = NULL;
    mxArray * num_stages = NULL;
    mxArray * data_indices = NULL;
    mxArray * num_windows = NULL;
    mxArray * data_locations = NULL;
    mxArray * time_locations = NULL;
    mxArray * features = NULL;
    mxArray * search_params = NULL;
    mclCopyArray(&track);
    mclCopyArray(&global_classifiers);
    /*
     * test_track(track, global_classifiers)
     * 
     * search_params.window_size = global_classifiers(1).window_length;
     */
    mlfIndexAssign(
      &search_params,
      ".window_size",
      mlfIndexRef(
        mclVa(global_classifiers, "global_classifiers"),
        "(?).window_length",
        _mxarray0_));
    /*
     * search_params.window_step = floor(search_params.window_size/8);
     */
    mlfIndexAssign(
      &search_params,
      ".window_step",
      mlfFloor(
        mclFeval(
          mclValueVarargout(),
          mlxMrdivide,
          mlfIndexRef(mclVv(search_params, "search_params"), ".window_size"),
          _mxarray1_,
          NULL)));
    /*
     * 
     * [features, time_locations, data_locations] = ...
     * extract_global_features_track(track, global_classifiers(1).fft_params, search_params);        
     */
    mclFeval(
      mlfVarargout(&features, &time_locations, &data_locations, NULL),
      mlxExtract_global_features_track,
      mclVa(track, "track"),
      mlfIndexRef(
        mclVa(global_classifiers, "global_classifiers"),
        "(?).fft_params",
        _mxarray0_),
      mclVv(search_params, "search_params"),
      NULL);
    /*
     * 
     * features = transpose(features);
     */
    mlfAssign(&features, mlfTranspose(mclVv(features, "features")));
    /*
     * 
     * num_windows = size(features, 1);
     */
    mlfAssign(
      &num_windows,
      mlfSize(mclValueVarargout(), mclVv(features, "features"), _mxarray0_));
    /*
     * data_indices = (1:size(features, 1));
     */
    mlfAssign(
      &data_indices,
      mlfColon(
        _mxarray0_,
        mlfSize(mclValueVarargout(), mclVv(features, "features"), _mxarray0_),
        NULL));
    /*
     * 
     * num_stages = length(global_classifiers);
     */
    mlfAssign(
      &num_stages,
      mlfScalar(mclLengthInt(mclVa(global_classifiers, "global_classifiers"))));
    /*
     * 
     * passed_indices = 0;
     */
    mlfAssign(&passed_indices, _mxarray2_);
    /*
     * 
     * for stage = 1:num_stages
     */
    {
        int v_ = mclForIntStart(1);
        int e_ = mclForIntEnd(mclVv(num_stages, "num_stages"));
        if (v_ > e_) {
            mlfAssign(&stage, _mxarray3_);
        } else {
            /*
             * 
             * if stage > 1
             * features = features(passed_indices, :);            
             * end
             * 
             * confidences = zeros(size(features, 1), 1);    
             * num_trees = length(global_classifiers(stage).wcs);
             * 
             * for t = 1:num_trees            
             * [class_labels, node_ids] = treeval(global_classifiers(stage).wcs(t).tree, features);
             * for s = 1:length(node_ids)
             * confidences(s) = confidences(s) + global_classifiers(stage).wcs(t).node_confidences(node_ids(s));
             * end
             * end            
             * 
             * % get passed examples
             * passed_indices = zeros(length(class_labels), 1);
             * num_passed = 0;
             * for s = 1:length(class_labels)
             * if confidences(s) > global_classifiers(stage).threshold
             * num_passed = num_passed + 1;
             * passed_indices(num_passed) = s;
             * end
             * end
             * passed_indices = passed_indices(1:num_passed);
             * 
             * data_indices = data_indices(passed_indices);
             * 
             * passed_times = zeros(num_passed, 1);        
             * 
             * passed_times = time_locations(data_indices);
             * confidences = confidences(passed_indices);
             * 
             * end
             */
            for (; ; ) {
                if (mclGtBool(mlfScalar(v_), _mxarray0_)) {
                    mlfAssign(
                      &features,
                      mclArrayRef2(
                        mclVv(features, "features"),
                        mclVv(passed_indices, "passed_indices"),
                        mlfCreateColonIndex()));
                }
                mlfAssign(
                  confidences,
                  mlfZeros(
                    mlfSize(
                      mclValueVarargout(),
                      mclVv(features, "features"),
                      _mxarray0_),
                    _mxarray0_,
                    NULL));
                mlfAssign(
                  &num_trees,
                  mclFeval(
                    mclValueVarargout(),
                    mlxLength,
                    mlfIndexRef(
                      mclVa(global_classifiers, "global_classifiers"),
                      "(?).wcs",
                      mlfScalar(v_)),
                    NULL));
                {
                    int v_0 = mclForIntStart(1);
                    int e_0 = mclForIntEnd(mclVv(num_trees, "num_trees"));
                    if (v_0 > e_0) {
                        mlfAssign(&t, _mxarray3_);
                    } else {
                        for (; ; ) {
                            mclFeval(
                              mlfVarargout(&class_labels, &node_ids, NULL),
                              mlxTreeval,
                              mlfIndexRef(
                                mclVa(global_classifiers, "global_classifiers"),
                                "(?).wcs(?).tree",
                                mlfScalar(v_),
                                mlfScalar(v_0)),
                              mclVv(features, "features"),
                              NULL);
                            {
                                int v_1 = mclForIntStart(1);
                                int e_1
                                  = mclLengthInt(mclVv(node_ids, "node_ids"));
                                if (v_1 > e_1) {
                                    mlfAssign(&s, _mxarray3_);
                                } else {
                                    for (; ; ) {
                                        mclIntArrayAssign1(
                                          confidences,
                                          mclFeval(
                                            mclValueVarargout(),
                                            mlxPlus,
                                            mclIntArrayRef1(
                                              mclVv(
                                                *confidences, "confidences"),
                                              v_1),
                                            mlfIndexRef(
                                              mclVa(
                                                global_classifiers,
                                                "global_classifiers"),
                                              "(?).wcs(?).node_confidences(?)",
                                              mlfScalar(v_),
                                              mlfScalar(v_0),
                                              mclIntArrayRef1(
                                                mclVv(node_ids, "node_ids"),
                                                v_1)),
                                            NULL),
                                          v_1);
                                        if (v_1 == e_1) {
                                            break;
                                        }
                                        ++v_1;
                                    }
                                    mlfAssign(&s, mlfScalar(v_1));
                                }
                            }
                            if (v_0 == e_0) {
                                break;
                            }
                            ++v_0;
                        }
                        mlfAssign(&t, mlfScalar(v_0));
                    }
                }
                mlfAssign(
                  &passed_indices,
                  mlfZeros(
                    mlfScalar(
                      mclLengthInt(mclVv(class_labels, "class_labels"))),
                    _mxarray0_,
                    NULL));
                mlfAssign(&num_passed, _mxarray2_);
                {
                    int v_2 = mclForIntStart(1);
                    int e_2 = mclLengthInt(mclVv(class_labels, "class_labels"));
                    if (v_2 > e_2) {
                        mlfAssign(&s, _mxarray3_);
                    } else {
                        for (; ; ) {
                            if (mlfTobool(
                                  mclFeval(
                                    mclValueVarargout(),
                                    mlxGt,
                                    mclIntArrayRef1(
                                      mclVv(*confidences, "confidences"), v_2),
                                    mlfIndexRef(
                                      mclVa(
                                        global_classifiers,
                                        "global_classifiers"),
                                      "(?).threshold",
                                      mlfScalar(v_)),
                                    NULL))) {
                                mlfAssign(
                                  &num_passed,
                                  mclPlus(
                                    mclVv(num_passed, "num_passed"),
                                    _mxarray0_));
                                mclArrayAssign1(
                                  &passed_indices,
                                  mlfScalar(v_2),
                                  mclVv(num_passed, "num_passed"));
                            }
                            if (v_2 == e_2) {
                                break;
                            }
                            ++v_2;
                        }
                        mlfAssign(&s, mlfScalar(v_2));
                    }
                }
                mlfAssign(
                  &passed_indices,
                  mclArrayRef1(
                    mclVv(passed_indices, "passed_indices"),
                    mlfColon(
                      _mxarray0_, mclVv(num_passed, "num_passed"), NULL)));
                mlfAssign(
                  &data_indices,
                  mclArrayRef1(
                    mclVv(data_indices, "data_indices"),
                    mclVv(passed_indices, "passed_indices")));
                mlfAssign(
                  &passed_times,
                  mlfZeros(mclVv(num_passed, "num_passed"), _mxarray0_, NULL));
                mlfAssign(
                  &passed_times,
                  mclArrayRef1(
                    mclVv(time_locations, "time_locations"),
                    mclVv(data_indices, "data_indices")));
                mlfAssign(
                  confidences,
                  mclArrayRef1(
                    mclVv(*confidences, "confidences"),
                    mclVv(passed_indices, "passed_indices")));
                if (v_ == e_) {
                    break;
                }
                ++v_;
            }
            mlfAssign(&stage, mlfScalar(v_));
        }
    }
    /*
     * 
     * passed_times = time_locations(data_indices);
     */
    mlfAssign(
      &passed_times,
      mclArrayRef1(
        mclVv(time_locations, "time_locations"),
        mclVv(data_indices, "data_indices")));
    /*
     * passed_data = data_locations(data_indices, :);
     */
    mlfAssign(
      &passed_data,
      mclArrayRef2(
        mclVv(data_locations, "data_locations"),
        mclVv(data_indices, "data_indices"),
        mlfCreateColonIndex()));
    /*
     * 
     * fs = global_classifiers(1).fft_params.fs;
     */
    mlfAssign(
      &fs,
      mlfIndexRef(
        mclVa(global_classifiers, "global_classifiers"),
        "(?).fft_params.fs",
        _mxarray0_));
    /*
     * width = time_locations(1)*2*fs;
     */
    mlfAssign(
      &width,
      mclMtimes(
        mclMtimes(
          mclIntArrayRef1(mclVv(time_locations, "time_locations"), 1),
          _mxarray4_),
        mclVv(fs, "fs")));
    /*
     * [passed_times, confidences2] = remove_close_matches(passed_times, confidences, width/fs/2);
     */
    mlfAssign(
      &passed_times,
      mlfRemove_close_matches(
        &confidences2,
        NULL,
        mclVv(passed_times, "passed_times"),
        mclVv(*confidences, "confidences"),
        mclMrdivide(
          mclMrdivide(mclVv(width, "width"), mclVv(fs, "fs")), _mxarray4_)));
    /*
     * 
     * X = -sortrows(-[confidences2 passed_times]);
     */
    mlfAssign(
      &X,
      mclUminus(
        mlfSortrows(
          NULL,
          mclUminus(
            mlfHorzcat(
              mclVv(confidences2, "confidences2"),
              mclVv(passed_times, "passed_times"),
              NULL)),
          NULL)));
    /*
     * confidences = X(:, 1);
     */
    mlfAssign(
      confidences,
      mclArrayRef2(mclVv(X, "X"), mlfCreateColonIndex(), _mxarray0_));
    /*
     * passed_times = X(:, 2);
     */
    mlfAssign(
      &passed_times,
      mclArrayRef2(mclVv(X, "X"), mlfCreateColonIndex(), _mxarray4_));
    /*
     * 
     * num_passed = length(passed_times);
     */
    mlfAssign(
      &num_passed,
      mlfScalar(mclLengthInt(mclVv(passed_times, "passed_times"))));
    mclValidateOutput(passed_times, 1, nargout_, "passed_times", "test_track");
    mclValidateOutput(*confidences, 2, nargout_, "confidences", "test_track");
    mxDestroyArray(search_params);
    mxDestroyArray(features);
    mxDestroyArray(time_locations);
    mxDestroyArray(data_locations);
    mxDestroyArray(num_windows);
    mxDestroyArray(data_indices);
    mxDestroyArray(num_stages);
    mxDestroyArray(passed_indices);
    mxDestroyArray(stage);
    mxDestroyArray(num_trees);
    mxDestroyArray(t);
    mxDestroyArray(class_labels);
    mxDestroyArray(node_ids);
    mxDestroyArray(s);
    mxDestroyArray(num_passed);
    mxDestroyArray(passed_data);
    mxDestroyArray(fs);
    mxDestroyArray(width);
    mxDestroyArray(confidences2);
    mxDestroyArray(X);
    mxDestroyArray(global_classifiers);
    mxDestroyArray(track);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return passed_times;
}
