


object_name(1).name = 'car_horn';
object_name(2).name = 'close_door';
object_name(3).name = 'dog_bark';
object_name(4).name = 'door_bell';
object_name(5).name = 'explosion';
object_name(6).name = 'female_laugh';
object_name(7).name = 'gunshot';
object_name(8).name = 'laser_gun';
object_name(9).name = 'light_saber';
object_name(10).name = 'male_laugh';
object_name(11).name = 'meow';
object_name(12).name = 'phone';
object_name(13).name = 'scream';
object_name(14).name = 'swords';

stage = 2;

%for stage = 1:3

for i = first_obj:last_obj
    %try
    error_dir = ['./tmp/' object_name(i).name];
    if exist(error_dir) == 0
        mkdir('./tmp', object_name(i).name);
    end
    %delete(['./tmp/' object_name(i).name '/*.wav']);    
    
    for s = 1:stage-1
        load(['./data/online_training/' object_name(i).name '/global_classifier', num2str(s), '.mat']);
        prev_classifier(s) = global_classifier;
    end
    
    
    disp(['training ' object_name(i).name]);
    if stage == 1
        global_classifier = train_global('./data', ...
            ['./data/online_training/' object_name(i).name '/positive_list.txt'], ...
            ['./data/online_training/' object_name(i).name '/negative_list.txt'], ...
            50, 1000, training_params, error_dir);
    else
        global_classifier = train_global('./data', ...
            ['./data/online_training/' object_name(i).name '/positive_list.txt'], ...
            ['./data/online_training/' object_name(i).name '/negative_list.txt'], ...
            50, 1000, training_params, error_dir, ...
            stage-1, prev_classifier);
    end
    global_classifier.training_params = training_params;
    save(['./data/online_training/' object_name(i).name '/global_classifier', num2str(stage), '.mat'], 'global_classifier');
    disp('  ');
    %catch
    %    lasterr
    %end
end

%end