/*
 * MATLAB Compiler: 3.0
 * Date: Wed Aug 25 13:58:14 2004
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-W" "main" "-L" "C"
 * "-t" "-T" "link:lib" "-h" "load_classifiers" "libmmfile.mlib" "-v" 
 */
#include "load_classifiers.h"
#include "libmatlbm.h"
#include "libmmfile.h"
static mxArray * _mxarray0_;

static mxChar _array2_[18] = { '/', 'g', 'l', 'o', 'b', 'a', 'l', '_', 'c',
                               'l', 'a', 's', 's', 'i', 'f', 'i', 'e', 'r' };
static mxArray * _mxarray1_;

static mxChar _array4_[4] = { '.', 'm', 'a', 't' };
static mxArray * _mxarray3_;

void InitializeModule_load_classifiers(void) {
    _mxarray0_ = mclInitializeDoubleVector(0, 0, (double *)NULL);
    _mxarray1_ = mclInitializeString(18, _array2_);
    _mxarray3_ = mclInitializeString(4, _array4_);
}

void TerminateModule_load_classifiers(void) {
    mxDestroyArray(_mxarray3_);
    mxDestroyArray(_mxarray1_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mload_classifiers(int nargout_,
                                   mxArray * classifier_dir,
                                   mxArray * num_stages);

_mexLocalFunctionTable _local_function_table_load_classifiers
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfLoad_classifiers" contains the normal interface for the
 * "load_classifiers" M-function from file
 * "/afs/cs.cmu.edu/user/dhoiem/code_for_c/load_classifiers.m" (lines 1-6).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfLoad_classifiers(mxArray * classifier_dir, mxArray * num_stages) {
    int nargout = 1;
    mxArray * classifiers = NULL;
    mlfEnterNewContext(0, 2, classifier_dir, num_stages);
    classifiers = Mload_classifiers(nargout, classifier_dir, num_stages);
    mlfRestorePreviousContext(0, 2, classifier_dir, num_stages);
    return mlfReturnValue(classifiers);
}

/*
 * The function "mlxLoad_classifiers" contains the feval interface for the
 * "load_classifiers" M-function from file
 * "/afs/cs.cmu.edu/user/dhoiem/code_for_c/load_classifiers.m" (lines 1-6). The
 * feval function calls the implementation version of load_classifiers through
 * this function. This function processes any input arguments and passes them
 * to the implementation version of the function, appearing above.
 */
void mlxLoad_classifiers(int nlhs,
                         mxArray * plhs[],
                         int nrhs,
                         mxArray * prhs[]) {
    mxArray * mprhs[2];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: load_classifiers Line: 1 Colum"
            "n: 1 The function \"load_classifiers\" was called wi"
            "th more than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: load_classifiers Line: 1 Colu"
            "mn: 1 The function \"load_classifiers\" was called "
            "with more than the declared number of inputs (2)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 2 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 2; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 2, mprhs[0], mprhs[1]);
    mplhs[0] = Mload_classifiers(nlhs, mprhs[0], mprhs[1]);
    mlfRestorePreviousContext(0, 2, mprhs[0], mprhs[1]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mload_classifiers" is the implementation version of the
 * "load_classifiers" M-function from file
 * "/afs/cs.cmu.edu/user/dhoiem/code_for_c/load_classifiers.m" (lines 1-6). It
 * contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function classifiers = load_classifiers(classifier_dir, num_stages)
 */
static mxArray * Mload_classifiers(int nargout_,
                                   mxArray * classifier_dir,
                                   mxArray * num_stages) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(
          &_local_function_table_load_classifiers);
    mxArray * classifiers = NULL;
    mxArray * global_classifier = NULL;
    mxArray * ans = NULL;
    mxArray * s = NULL;
    mclCopyArray(&classifier_dir);
    mclCopyArray(&num_stages);
    /*
     * for s = 1:num_stages
     */
    {
        int v_ = mclForIntStart(1);
        int e_ = mclForIntEnd(mclVa(num_stages, "num_stages"));
        if (v_ > e_) {
            mlfAssign(&s, _mxarray0_);
        } else {
            /*
             * load([classifier_dir '/global_classifier' num2str(s) '.mat']);
             * classifiers(s) = global_classifier;
             * end
             */
            for (; ; ) {
                mclLoadConditional(
                  mlfHorzcat(
                    mclVa(classifier_dir, "classifier_dir"),
                    _mxarray1_,
                    mlfNum2str(mlfScalar(v_), NULL),
                    _mxarray3_,
                    NULL),
                  "ans",
                  &ans,
                  "classifier_dir",
                  &classifier_dir,
                  "classifiers",
                  &classifiers,
                  "global_classifier",
                  &global_classifier,
                  "num_stages",
                  &num_stages,
                  "s",
                  &s,
                  NULL);
                mclIntArrayAssign1(
                  &classifiers,
                  mclVv(global_classifier, "global_classifier"),
                  v_);
                if (v_ == e_) {
                    break;
                }
                ++v_;
            }
            mlfAssign(&s, mlfScalar(v_));
        }
    }
    mclValidateOutput(
      classifiers, 1, nargout_, "classifiers", "load_classifiers");
    mxDestroyArray(s);
    mxDestroyArray(ans);
    mxDestroyArray(global_classifier);
    mxDestroyArray(num_stages);
    mxDestroyArray(classifier_dir);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return classifiers;
    /*
     * 
     */
}
